;; -*- lexical-binding: t; -*-
;; Ce fichier de configuration est utilisé pour le cours de Système 1 (Semestre 2 de L1 info)
;; Ce fichier est géré par Olivier Baldellon <olivier.baldellon@univ-cotedazur.fr>
;; Vous n’avez pas les droits pour modifier ce fichier.
;; Vous pouvez choisir de l’ignorer en modifiant la ligne correspondante dans votre .emacs


;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;                                  ;;
;;  Petites améliorations diverses  ;;
;;                                  ;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;


;; Permet de passer d’une fenêtre à l’autre en faisant MAJ-flèche
;; directionnelle
(windmove-default-keybindings)


;; Permet d’associer visuellement parenthèses ouvrantes et fermantes
(show-paren-mode t)


;; Pour rendre la sélection plus lisible
(unless (display-graphic-p)
  ;;    (set-face-attribute 'region nil :background "#AA0")
  ;; si on est dans un terminal on supprime tout les machins
  ;; graphiques : c’est pour les faibles !
  (menu-bar-mode -1)
  (tool-bar-mode -1)
  (scroll-bar-mode -1))


;; Lorsqu’on souhaite quitter alors qu’un terminal (shell, python,
;; etc) est ouvert, Emacs demande toujours confirmation pour fermer ce
;; shell. La commande suivante désactive cette confirmation.
(setq confirm-kill-processes nil)


;; On affiche l'heure au format 24h
(setq display-time-24hr-format t)
(display-time-mode t)


;; On affiche le numéro de la colonne (à côté du numéro de ligne) de
;; la position du curseur
(setq column-number-mode t)


;; Permet de taper y au lieu de yes
(fset 'yes-or-no-p 'y-or-n-p)
(fset 'yes-or-no 'y-or-n)

;; La recherche est insensible à la casse
(setq-default case-fold-search t)

;; Pour rendre la sélection plus visible
;(set-face-attribute 'region nil :background "#AA0")


;; Pour éviter des fichiers de sauvegarde tout moche…
(setq backup-directory-alist '(("." . "~/.emacs-backup-files/")))

;; Autre
(setq current-language-environment "UTF-8")


;; Les lignes trop longues sont affiché que plusieurs lignes sous
;; emacs. Le mode suivant permet d’indiquer que les raccourcies C-a
;; C-e ou C-k fonctionnent sur le lignes "visuelles" et non pas réelles.
(global-visual-line-mode)


;; Pour gérer proprement le . Le symbole  est obtenue avec les
;; touches : C-q C-l et permet d’insérer un symbole « page break ».
;; Ce symbole, considéré comme un espace, permet de se déplacer
;; rapidement avec les combinaisons de touche C-PageUP et C-PageDOWN.
(global-set-key (kbd "C-<prior>") 'backward-page)
(global-set-key (kbd "C-<next>") 'forward-page)


;; Pour zoomer avec la souris
(global-set-key (kbd "<C-wheel-down>") 'text-scale-decrease)
(global-set-key (kbd "<C-wheel-up>") 'text-scale-increase)

;; Mode dired amélioré : permet entre autre d’ajouter le raccourci :
;; C-x C-j
(require 'dired-x)


;; Permet d’afficher des couleurs dans le man d’Emacs
(require 'man)
(set-face-attribute 'Man-overstrike nil :inherit font-lock-type-face :bold t)
(set-face-attribute 'Man-underline nil :inherit font-lock-keyword-face :underline nil)


;; Pour ceux qui font du Emacs Lisp
(setq initial-scratch-message ";; -*- lexical-binding: t; -*-\n\n")


;;;;;;;;;;;;;;
;;          ;;
;;  Autres  ;;
;;          ;;
;;;;;;;;;;;;;;

;; La suite du fichier correspond au point emacs initial
;; Je ne sais pas dans quelle mesure ces lignes sont pertinentes
;; Dans le doute je les laisse.

(setq shell-prompt-pattern "\\w+(.+)[0-9]+:") ;; Shell

;; Liste des tampons
(substitute-key-definition 'list-buffers 'electric-buffer-list global-map)
					; c'est tellement plus commode

;; Touches

; Pour voir ce qu'envoient les touches:
(defun voir-cars ()
       "Affiche les caracteres tapes, se termine apres 3 secondes."
       (interactive)
       (let ((caracs "")
	     (inhibit-quit t))
	 (message "Taper les caracteres, fin apres 3 secondes sans rien.")
	 (while (not (sit-for 3))
	   (setq caracs (concat caracs (list (read-char))
		 quit-flag nil)))	; peut etre leve par ^G
         (message "Caracteres lus: %s" (key-description caracs))))

;; Saveplace

; (load "saveplace" nil t)
; (setq-default save-place t)
; (define-key ctl-x-map "p" 'toggle-save-place)


;;; Utiliser W3 comme navigateur par defaut
(setq browse-url-browser-function 'browse-url-w3)

;;; Additions faites par Emacs lui-même

;; (Custom-set-variables
;;  '(display-time-use-mail-icon t)
;;  '(default-mime-charset (quote latin-1))
;;  '(auto-save-list-file-prefix nil)
;;  '(make-backup-files t)
;;  '(mime-button-mouse-face (quote highlight))
;;  '(mime-transfer-level 8 t))


(custom-set-variables
 ;; custom-set-variables was added by Custom.
 ;; If you edit it by hand, you could mess it up, so be careful.
 ;; Your init file should contain only one such instance.
 ;; If there is more than one, they won't work right.
; '(custom-enabled-themes '(wombat))
 '(package-selected-packages '(eat tuareg)))
(custom-set-faces
 ;; custom-set-faces was added by Custom.
 ;; If you edit it by hand, you could mess it up, so be careful.
 ;; Your init file should contain only one such instance.
 ;; If there is more than one, they won't work right.
 )
