(defface upinfo-aide-0 '((t :inherit font-lock-keyword-face))
  "font face for property keywords."
  :group 'upinfo
  )

(defface upinfo-aide-1 '((t :inherit font-lock-string-face :weight bold))
  "font face for property keywords."
  :group 'upinfo
  )

(defface upinfo-aide-2 '((t :inherit font-lock-builtin-face :weight bold))
  "font face for property keywords."
  :group 'upinfo
  )




(defvar upinfo/aide-buffer "*Aide*" "Nom du buffer pour afficher l’aide pour le cours de système 1")


(defun upinfo/face-titre (chaîne)
  (put-text-property 0 (length chaîne) 'face 'upinfo-aide-0
                     chaîne)
  chaîne)

(defun upinfo/face-raccourci (chaîne)
  (put-text-property 0 (length chaîne) 'face 'upinfo-aide-1
                     chaîne)
  chaîne)

(defun upinfo/face-important (chaîne)
  (put-text-property 0 (length chaîne) 'face 'upinfo-aide-2
                     chaîne)
  chaîne)


(defun upinfo/insérer-raccourci (commande description)
  (insert (format "%s : %s\n" (upinfo/face-raccourci commande) description)))

(defsubst upinfo/créer-raccourci (commande description)
  (format "%s : %s\n" (upinfo/face-raccourci commande) description))


(defun upinfo/insérer-section (titre &rest texte)
  (insert (upinfo/face-titre "== ")
          (upinfo/face-titre titre)
          (upinfo/face-titre " ==\n\n"))
  (dolist (chaîne texte)
    (insert chaîne)))


;; (defsubst upinfo/insérer-section-raccourcies (titre &rest texte)
;;   (declare (indent defun))
;;   (concat
;;    (insert (upinfo/face-titre "\n== ")
;;            (upinfo/face-titre titre)
;;           (upinfo/face-titre " ==\n"))

;;    (cl-loop for (commande description) on texte by #'cddr do
;;             (upinfo/insérer-raccourci commande description)))

(defsubst upinfo/créer-section-raccourcies (titre &rest texte)
  (declare (indent defun))
    (apply #'concat `( ,(upinfo/face-titre "\n== ")
                       ,(upinfo/face-titre titre)
                       ,(upinfo/face-titre " ==\n")
                       ,@(cl-loop for (commande description) on texte by #'cddr
                                  collect (upinfo/créer-raccourci commande description)))))




(defvar upinfo/aide-contenu nil)

(setq upinfo/aide-contenu
    (concat
     (upinfo/face-titre "                           *Mon aide-mémoire GNU/Emacs*\n\n")

     "Dans la suite "
     (upinfo/face-raccourci "C")
     " représente la touche « "
     (upinfo/face-important "Ctrl")
     " » de votre clavier\n"

     "              "
     (upinfo/face-raccourci "M")
     " représente la touche « "
     (upinfo/face-important "Alt")
     " » de votre clavier\n"

     "              "
     (upinfo/face-raccourci "S")
     " représente la touche « "
     (upinfo/face-important "Shift")
     " » de votre clavier (la majuscule au dessus de Ctrl)\n"
     "\n"

     (upinfo/face-raccourci "C-x C-b")
     (upinfo/face-important " On commence ")
     "par appuyer sur Ctrl et x en même temps,"
     (upinfo/face-important " puis ")
     "en même temps Ctrl et b"
     "\n"

     (upinfo/face-raccourci "C-x b  ")
     (upinfo/face-important " On commence ")
     "par appuyer sur Ctrl et x en même temps,"
     (upinfo/face-important " puis ")
     "ensuite seulement b"
     "\n"

       (upinfo/créer-section-raccourcies "Annuler"
    "C-g" "J’ai commencé un raccourci et je veux annuler"
    "C-g" "Emacs fait des trucs bizarres et je veux annuler"
    "C-x u" "J’annule la dernière action faite par emacs")


  (upinfo/créer-section-raccourcies "Gestion des fichiers"
    "C-x C-f" "ouvre un nouveau fichier"
    "C-x C-s" "sauvegarde le fichier"
    "C-x C-j" (concat "ouvre le répertoire courant (mode dired) ou "
                      (upinfo/face-raccourci "C-x d")))


  (upinfo/créer-section-raccourcies "Gestion des fenêtres"
    "S-<flèche>" "Se déplacer dans les fenêtres"
    "C-x o" "Se déplace dans la fenêtre suivante"
    "C-x 0" "Ferme la fenêtre courante"
    "C-x 1" "Ferme toutes les fenêtres sauf la courante"
    "C-x 2" "Ouvre une nouvelle fenêtre horizontalement"
    "C-x 3" "Ouvre une nouvelle fenêtre verticalement")

  (upinfo/créer-section-raccourcies "Se déplacer efficacement"
    "C-a" "Allez en début de ligne"
    "C-e" "Aller en fin de ligne"
    "C-<" "Aller au début du buffer (c’est-à-dire du fichier)"
    "C->" "Aller en fin de buffer (c’est-à-dire de fichier)")


  (upinfo/créer-section-raccourcies "Sélectionner du texte"
    "C-<espace>" "Commence la sélection"
    "<flèche>" "Déplace le curseur pour modifier la sélection")


  (upinfo/créer-section-raccourcies "Copier Coller"
    "M-w" "copier la sélection"
    "C-w" "coupe la sélection"
    "C-k" "Coupe jusqu’à la fin de la ligne"
    "C-y" "coller")


  (upinfo/créer-section-raccourcies "Chercher et remplacer"
    "C-s" "recherche vers l’avant"
    "C-r" "recherche une chaîne en arrière"
    "M-%" "recherche et remplace")


  (upinfo/créer-section-raccourcies "Utiliser les macro"
    "C-x (" "Débuter l’enregistrement de la macro"
    "C-x )" "Finir l’enregistrement de la macro"
    "C-x e" (concat "lancer la macro (puis simplement " (upinfo/face-raccourci "e") " pour répéter)"))

  "\n"
  "     "))


(defun upinfo/insert-aide ()
  (insert upinfo/aide-contenu)
  (insert-text-button "[Quitter l’aide]" 'action 'upinfo/quitter-aide
                      'follow-link t
                      'help-echo "Fermer cette fenêtre"
                      'help-args nil))




(defun aide ()
  "Affiche les principaux raccourcis clavier d’emacs"
  (interactive)
  (with-output-to-temp-buffer upinfo/aide-buffer)
  (with-current-buffer upinfo/aide-buffer
    (goto-char (point-max))
    (let ((inhibit-read-only t))
      (upinfo/insert-aide)
      (goto-char 0))))


;; (defun aide-silencieuse ()
;;   "Affiche les principaux raccourcis clavier d’emacs"
;;   (interactive)
;;   (let ((buf (generate-new-buffer upinfo/aide-buffer)))
;;     (set-buffer buf)
;;                                         ;(goto-char (point-max))
;;     (let ((inhibit-read-only t))
;;       (insert upinfo/aide-contenu)
;;       (goto-char 0))
;;     ))



(defun upinfo/quitter-aide (&rest inutile)
  (interactive)
  (delete-windows-on upinfo/aide-buffer))



(defun upinfo/démarrage ()
  "À mettre dans le hook"
  (interactive)
  (unless (cl-remove-if-not #'buffer-file-name (buffer-list))
    (aide)
    (switch-to-buffer upinfo/aide-buffer)
    (delete-other-windows)))

;;    (switch-to-buffer upinfo/aide-buffer)))






(defvar menu-aide-upinfo (make-sparse-keymap "Mine"))


;; Make a menu keymap (with a prompt string)
;; and make it the menu bar item’s definition.
(define-key-after global-map [menu-bar menu-aide-upinfo]
            (cons "Aide UPInfo" menu-aide-upinfo))


;; Define specific subcommands in this menu.
(define-key menu-aide-upinfo [aide]
            '(menu-item "Principaux raccourcis clavier" aide :help "Affiche l’aide"))
